#include <stdio.h>
#include "Comm.h"
#include "LALStdlib.h"
#include "Stubs.h"

void
Master (Status *status, mpiid id)
{
  MessageExchange  xMesgPar;
  TemplateExchange xTmplPar;
  DataExchange     xDataPar;
  EventExchange    xEvntPar;
  RequestExchange  xRqstPar;

  xEvntPar.send = xMesgPar.send = xRqstPar.send = 0;
  xTmplPar.send = xDataPar.send = 1;

  while (id.numprocs > 1)
  {
    ExchangeMessage (status, &xMesgPar);
    printf ("Master got request %s (= %d) from slave %d\n",
            xMesgPar.type, xMesgPar.message, xMesgPar.source);

    switch (xMesgPar.message)
    {
      case Finished:
        --id.numprocs;
        break;

      case Templates:
        xRqstPar.source = xMesgPar.source;
        ExchangeRequest (status, &xRqstPar);
        printf ("Template bank requested with fitting factor %f\n",
                xRqstPar.list.fitfact);
        PrintTemplate (&(xRqstPar.list.template), 1, id);
        CreateTemplates (&xTmplPar.list, xTmplPar.number = 4);
        xTmplPar.destination = xMesgPar.source;
        ExchangeTemplates (status, &xTmplPar);
        LALFree (xTmplPar.list);

      case Data:
        CreateData (&xDataPar.list, xDataPar.number = 4);
        xDataPar.destination = xMesgPar.source;
        ExchangeData (status, &xDataPar);
        LALFree (xDataPar.list);

      case Events:
        xEvntPar.source = xMesgPar.source;
        ExchangeEvents (status, &xEvntPar);
        PrintEvents (xEvntPar.list, xEvntPar.number, xEvntPar.source);
        break;

      case Error:
        printf ("Master got an error message from slave %d\n", xMesgPar.source);
        break;

      default:
        printf ("Invalid message %d from slave %d\n",
                xMesgPar.message, xMesgPar.source);
        break;
    }

  }

  printf ("Master shutting down\n");
  return;
}
