#include <stdio.h>
#include "Comm.h"
#include "LALStdlib.h"
#include "Stubs.h"

void
Slave (Status *status, mpiid id)
{
  MessageExchange  xMesgPar;
  TemplateExchange xTmplPar;
  DataExchange     xDataPar;
  EventExchange    xEvntPar;
  RequestExchange  xRqstPar;

  xEvntPar.send = xMesgPar.send = xRqstPar.send = 1;
  xTmplPar.send = xDataPar.send = 0;

  /* excercise the master */

  /* get templates */
  xMesgPar.message = Templates;
  ExchangeMessage (status, &xMesgPar);
  xRqstPar.list.fitfact = 0.8;
  xRqstPar.list.template.m1 = 1.35;
  xRqstPar.list.template.m2 = 1.45;
  xRqstPar.list.template.templatenumber = 12345;
  ExchangeRequest   (status, &xRqstPar);
  ExchangeTemplates (status, &xTmplPar);
  if (xTmplPar.number == 0)
    goto exit;
  PrintTemplate (xTmplPar.list, xTmplPar.number, id);
  LALFree (xTmplPar.list);

  /* get data */
  xMesgPar.message = Data;
  ExchangeMessage (status, &xMesgPar);
  ExchangeData    (status, &xDataPar);
  if (xDataPar.number == 0)
    goto exit;
  PrintData (xDataPar.list, xDataPar.number, id);
  LALFree (xDataPar.list);

  /* send events */
  CreateEvents (&xEvntPar.list, xEvntPar.number = 5, id);
  xMesgPar.message = Events;
  ExchangeMessage (status, &xMesgPar);
  ExchangeEvents  (status, &xEvntPar);
  LALFree (xEvntPar.list);

  /* done */
exit:
  printf ("Slave %d exiting\n", id.myid);
  xMesgPar.message = Finished;
  ExchangeMessage (status, &xMesgPar);
  return;
}
