











/*----------------------------------------------------------------------- 
 * 
 * File Name: CreateVectorTest.c
 * 
 * Author: Finn, L. S. 
 * 
 * Revision: $Id: CreateVectorTest.m4,v 1.1 1999/10/05 01:36:59 jolien Exp $ 
 * 
 *----------------------------------------------------------------------- 
 * 
 * NAME 
 *   main()
 *
 * SYNOPSIS 
 * 
 * DESCRIPTION 
 *   Test suite for vector factories
 * 
 * DIAGNOSTICS
 *   Writes PASS, FAIL to stdout as tests are passed or failed. 
 *   Returns 0 if all tests passed and -1 if any test failed. 
 * 
 * CALLS
 *   CreateVector
 * 
 * NOTES
 *   CreateVector can't test LALMalloc failure without messing with
 *   LALMalloc
 * 
 *   Automatically generated from cvt.tmpl by m4
 * 
 *----------------------------------------------------------------------- 
 * 
 * REVISION HISTORY 
 * 
 * $Log: CreateVectorTest.m4$
 * 
 *-----------------------------------------------------------------------
 */

#ifndef _STDLIB_H
#include <stdlib.h>
#ifndef _STDLIB_H
#define _STDLIB_H
#endif
#endif

#ifndef _STDIO_H
#include <stdio.h>
#ifndef _STDIO_H
#define _STDIO_H
#endif
#endif

#ifndef _STRING_H
#include <string.h>
#ifndef _STRING_H
#define _STRING_H
#endif
#endif

#ifndef _LALDATATYPES_H
#include "LALDatatypes.h"
#ifndef _LALDATATYPES_H
#define _LALDATATYPES_H
#endif
#endif

#ifndef _AVFACTORIES_H
#include "AVFactories.h"
#ifndef _AVFACTORIES_H
#define _AVFACTORIES_H
#endif
#endif

static volatile const CHAR MAIN[]="$Id: CreateVectorTest.m4$";

int debuglevel = 2;

typedef REAL4Vector vtype;
int main()
{

  Status status;		/*  */
  vtype *vector = NULL;		/*  */
  vtype vstor;
  INT4 length = 0;
  int rcode = 0;		/* return code */

  /* Test error returns */

  /* Sequence length */

  rcode++;			/* increment code for each test */
  CreateVector ( &status, &vector, 0 );
  if (status.statusCode != CREATEVECTOR_ELENGTH) 
    printf("FAIL zero sequence length: wrong status code\n");
  else if (strcmp(CREATEVECTOR_MSGELENGTH, status.statusDescription) != 0)
    printf("FAIL zero sequence length: statusDescription mismatch\n");
  else if (vector != NULL)
    printf("FAIL zero sequence length\n");
  else 
    { 
      rcode--;			/* decrement code if test passed */
      printf("PASS zero sequence length\n");
    }

  /* return structure */

  rcode++;			/* increment code for each test */
  length = 1;
  CreateVector ( &status, NULL, length );
  if (status.statusCode != CREATEVECTOR_EVPTR) 
    printf("FAIL return struct ptr is NULL: wrong status code\n");
  else if (strcmp(CREATEVECTOR_MSGEVPTR, status.statusDescription) != 0)
    printf("FAIL return struct ptr is NULL: statusDescription mismatch\n");
  else 
    {
      rcode--;			/* decrement code if test passed */
      printf("PASS return struct ptr is NULL\n");
    }

  rcode++;			/* increment code for each test */
  vector = &vstor;
  CreateVector ( &status, &vector, length );
  if (status.statusCode != CREATEVECTOR_EUPTR) 
    printf("FAIL return struct points to non-NULL: wrong status code\n");
  else if (strcmp(CREATEVECTOR_MSGEUPTR, status.statusDescription) != 0)
    printf("FAIL return struct points to non-NULL: statusDescription mismatch\n");
  else if (vector != &vstor)
    printf("FAIL return struct points to non-NULL: return struct reset\n");
  else 
    {
      rcode--;			/* decrement code if test passed */
      printf("PASS return struct points to non-NULL\n");
    }

  /* Test allocations */

  rcode++;			/* increment code for each test */
  length = 10;			/* allocate this length */
  vector = NULL;		/* make sure we aren't pointing to anything */
  CreateVector ( &status, &vector, length );
  if (vector == NULL)
    printf("FAIL allocation: vector == NULL\n");
  else if (vector->data == NULL)
    printf("FAIL allocation: vector->data = NULL\n");
  else if (vector->length != length)
    printf("FAIL allocation: vector->length != length\n");
  else if (status.statusCode != 0)
    printf("FAIL allocation: non-zero status code legal allocation\n");
  else
    {
      rcode--;			/* decrement code if test passed */
      printf("PASS allocation\n");
    }

  /* We should have correctly set the status Id field: */

  printf ( "Test results for %s\n", status.Id );
  printf ( "Tested by %s\n", MAIN);

  exit((rcode==0)?0:-1);
}
  
